//	FDist - ObjectARX module for AutoCAD 2005
//	Copyright (C) 2005 Wiebe Leonid, All Rights Reserved.
//
//	This software is provided 'as-is', without any express or implied
//	warranty.  In no event will the authors be held liable for any
//	damages arising from the use of this software.
//
//	Permission is granted to anyone to use this software for any purpose,
//	including commercial applications, and to alter it and redistribute it
//	freely, subject to the following restrictions:
//
//	1.	The origin of this software must not be misrepresented; you must
//		not claim that you wrote the original software. If you use this
//		software in a product, an acknowledgment in the product
//		documentation would be appreciated but is not required.
//	2.	Altered source versions must be plainly marked as such, and must
//		not be misrepresented as being the original software.
//	3.	This notice may not be removed or altered from any source
//		distribution.

//	FDist -  ObjectARX  AutoCAD 2005
//	  2005,  
//
//	     ; 
//	   /     
//	     GNU   , 
//	      ; 
//	  2   (  )    .
//
//	   ,    , 
//	        ; 
//	    ,  
//	       . 
//	      GNU.
//
//	        GNU 
//	   ;    ,      
//	(Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA).

#include "stdafx.h"
//#include "Form.h"
#include "Dlg.h"

BOOL b = TRUE;

// Dlg dialog

IMPLEMENT_DYNAMIC(Dlg, CDialog)
Dlg::Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(Dlg::IDD, pParent)
	, m_bScale(TRUE)
{
}

Dlg::~Dlg()
{
}

BOOL Dlg::Create( CWnd* pParent )
{
    return CDialog::Create(Dlg::IDD, pParent);
}

void Dlg::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
DDX_Check(pDX, IDC_CHECK1, m_bScale);
DDX_Control(pDX, IDC_CHECK1, m_check);
DDX_Control(pDX, IDOK2, m_points);
DDX_Control(pDX, IDOK, m_elems);
}


BEGIN_MESSAGE_MAP(Dlg, CDialog)
	ON_MESSAGE( WM_ACAD_KEEPFOCUS, onAcadKeepFocus )
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDOK2, OnBnClickedOk2)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()

LRESULT Dlg::onAcadKeepFocus( WPARAM, LPARAM )
{
    return b;
}


// Dlg message handlers

////////////////////////////////
BOOL Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetDlgItemText(IDC_EDIT2, "0.000");

	return TRUE;
}




void Dlg::OnBnClickedOk()
{

    ads_name     ent;
    AcDbObjectId id;
	Acad::ErrorStatus es;
	long length = 0;
	double dist_all = 0.;
	double dist_all_scale = 0.;
	double dist = 0.;
	double param = 0.;
	char txt[100];
	double scale = 1.;
	long counter = 0;

	ads_name ss;

	SetDlgItemText(IDC_EDIT2, "0.000");

	UpdateData(TRUE);

	struct resbuf rb;
	acedGetVar("DIMLFAC", &rb);
	if (rb.restype == 5001) scale = rb.resval.rreal;

	m_check.EnableWindow(FALSE);
	m_points.EnableWindow(FALSE);
	m_elems.EnableWindow(FALSE);
	b = FALSE;

	if (RTNORM != acedSSGet( NULL, NULL, NULL, NULL, ss ))
	{
		acutPrintf( "\n \n" );
		m_check.EnableWindow(TRUE);
		m_points.EnableWindow(TRUE);
		m_elems.EnableWindow(TRUE);
		b = TRUE;
		acedPostCommandPrompt();
		return;
	}
	else
	{
	}

	if (!(RTNORM != acedSSLength( ss, &length ) || 0 == length))
	{
		dist_all = 0.;

		for (long i = 0; i < length; i++) 
		{

			if (RTNORM != acedSSName( ss, i, ent ))
				continue;
			if (Acad::eOk != acdbGetObjectId( id, ent ))
				continue;
			AcDbEntity* pEnt;
			if (Acad::eOk != acdbOpenAcDbEntity( pEnt, id, AcDb::kForRead ))
				continue;

			if (pEnt->isKindOf(AcDbCurve::desc()))
			{
				AcGePoint3d endPt;
				AcDbCurve* crv = (AcDbCurve*)pEnt;
				es = crv->getEndParam(param);
				if (es == Acad::eOk) 
					es = crv->getDistAtParam(param, dist);
				if (es == Acad::eOk) 
					dist_all += dist;
				if (m_bScale) 
					dist_all_scale = dist_all * scale; 
				else 
					dist_all_scale = dist_all;
				counter++;
			}

			pEnt->close();
	    
		}	

		if (counter < length) acutPrintf( "\n   = %i\n", length);
		acutPrintf( "\n  = %i,   = %.3f\n", counter, dist_all_scale);
		sprintf(txt, "%.3f", dist_all_scale);
		SetDlgItemText(IDC_EDIT2, txt);
	}

	acedSSFree( ss );

	m_check.EnableWindow(TRUE);
	m_points.EnableWindow(TRUE);
	m_elems.EnableWindow(TRUE);
	b = TRUE;
	acedPostCommandPrompt();


	//OnOK();
}





void Dlg::OnBnClickedOk2()
{
	AcGePoint3d pt1;
	AcGePoint3d pt2;
	bool bOk = false;
	bool bOk2 = false;
	int res = 0;
	double scale = 1.;
	double dist = 0.;
	double dist_scale = 0.;
	double dist_all = 0.;
	double dist_all_scale = 0.;
	char txt[100];

	SetDlgItemText(IDC_EDIT2, "0.000");

	UpdateData(TRUE);

	struct resbuf rb;
	acedGetVar("DIMLFAC", &rb);
	if (rb.restype == 5001) scale = rb.resval.rreal;

	m_check.EnableWindow(FALSE);
	m_points.EnableWindow(FALSE);
	m_elems.EnableWindow(FALSE);
	b = FALSE;

	while(true)
	{
		if (!bOk && !bOk2) 
			res = acedGetPoint(NULL, "\n     : \n", asDblArray(pt2));
		else if (bOk && !bOk2) 
			res = acedGetPoint(NULL, "\n     : \n", asDblArray(pt2));
		else
			res = acedGetPoint(NULL, ",   :\n", asDblArray(pt2));

		if (res == RTNORM)
		{
			if (bOk)
			{
				dist = pt2.distanceTo(pt1);
				pt1.x = pt2.x;
				pt1.y = pt2.y;
				pt1.z = pt2.z;
				dist_all += dist;
				if (m_bScale) 
				{
					dist_scale = dist * scale;
					dist_all_scale = dist_all * scale; 
				}
				else 
				{
					dist_scale = dist;
					dist_all_scale = dist_all;
				}
				acutPrintf( "\n  %.3f,   %.3f", dist_scale, dist_all_scale);
				sprintf(txt, "%.3f", dist_all_scale);
				SetDlgItemText(IDC_EDIT2, txt);
				bOk2 = true;
			}
			else
			{
				pt1.x = pt2.x;
				pt1.y = pt2.y;
				pt1.z = pt2.z;
				bOk = true;
			}
		}
		else
		{
			break;
		}
	}

	m_check.EnableWindow(TRUE);
	m_points.EnableWindow(TRUE);
	m_elems.EnableWindow(TRUE);
	b = TRUE;
	acedPostCommandPrompt();

}

/////////////////////
void Dlg::OnClose()
{

	//HWND wnd0 = adsw_acadMainWnd();
	////acutPrintf("\nWND0 - %i\n", wnd0);

	//HWND wnd1 = ::FindWindowEx(wnd0, NULL, "MDIClient", NULL);
	////acutPrintf("\nWND1 - %i\n", wnd1);

	//HWND wnd2 = ::FindWindowEx(wnd1, NULL, NULL, curDoc()->docTitle());
	////acutPrintf("\nWND2 - %i\n", wnd2);

	//HWND wnd3 = ::GetWindow(wnd2, GW_CHILD);
	////acutPrintf("\nWND3 - %i\n", wnd3);

	//while (true)
	//{
	//	
	//	LRESULT res;
	//	res = ::PostMessage(wnd3, WM_KEYDOWN, 0x0000001B, 0x00010001);
	//	res = ::PostMessage(wnd3, WM_KEYDOWN, 0x0000001B, 0x00010001);

	//	wnd3 = ::GetWindow(wnd3, GW_HWNDNEXT);
	//	//acutPrintf("\nWND3 - %i\n", wnd3);

	//	if (wnd3 == NULL) break;

	//}


	CDialog::OnClose();
}

////////////////////////////////
void Dlg::OnBnClickedButton1()
{
	MessageBox("FDist - ObjectARX module for AutoCAD 2005\nCopyright (C) 2005 Wiebe Leonid, All Rights Reserved.", " ", MB_OK);
}
