//	FDist - ObjectARX module for AutoCAD 2005
//	Copyright (C) 2005 Wiebe Leonid, All Rights Reserved.
//
//	This software is provided 'as-is', without any express or implied
//	warranty.  In no event will the authors be held liable for any
//	damages arising from the use of this software.
//
//	Permission is granted to anyone to use this software for any purpose,
//	including commercial applications, and to alter it and redistribute it
//	freely, subject to the following restrictions:
//
//	1.	The origin of this software must not be misrepresented; you must
//		not claim that you wrote the original software. If you use this
//		software in a product, an acknowledgment in the product
//		documentation would be appreciated but is not required.
//	2.	Altered source versions must be plainly marked as such, and must
//		not be misrepresented as being the original software.
//	3.	This notice may not be removed or altered from any source
//		distribution.

//	FDist -  ObjectARX  AutoCAD 2005
//	  2005,  
//
//	     ; 
//	   /     
//	     GNU   , 
//	      ; 
//	  2   (  )    .
//
//	   ,    , 
//	        ; 
//	    ,  
//	       . 
//	      GNU.
//
//	        GNU 
//	   ;    ,      
//	(Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA).

//-----------------------------------------------------------------------------
//----- acrxEntryPoint.h
//-----------------------------------------------------------------------------
#include "StdAfx.h"
#include "Dlg.h"

//-----------------------------------------------------------------------------
#define szRDS _RXST("W_")

Dlg* dlg = NULL;

//-----------------------------------------------------------------------------
//----- ObjectARX EntryPoint
class CFormApp : public AcRxArxApp {

public:
	CFormApp () : AcRxArxApp () {}

	virtual AcRx::AppRetCode On_kInitAppMsg (void *pkt) {
		AcRx::AppRetCode retCode =AcRxArxApp::On_kInitAppMsg (pkt) ;
		

		return (retCode) ;
	}

	virtual AcRx::AppRetCode On_kUnloadAppMsg (void *pkt) {
		AcRx::AppRetCode retCode =AcRxArxApp::On_kUnloadAppMsg (pkt) ;
		
		if (dlg != NULL) 
		{
			dlg->DestroyWindow();
			dlg = NULL;
		}

		return (retCode) ;
	}

	virtual void RegisterServerComponents () {
	}

	//////////////////////////////////
	static void W_Form_fdist(void)
	{
		CAcModuleResourceOverride resOverride;

		HWND hwndAcad = adsw_acadMainWnd();
		CWnd *pWnd = CWnd::FromHandle ( hwndAcad );
		if( dlg == NULL ) 
		{
			if ( (dlg = new Dlg ( pWnd )) == NULL )  return;

			BOOL succeeded = dlg->Create( pWnd );
			if ( !succeeded )
			{
				acutPrintf("\n   \n");
			}
		}

		if (dlg != NULL) 
		{
			dlg->OnInitDialog();
			dlg->ShowWindow(SW_SHOWNORMAL);
		}
		else
			acutPrintf("\n   !\n");
	}
} ;

//-----------------------------------------------------------------------------
IMPLEMENT_ARX_ENTRYPOINT(CFormApp)

ACED_ARXCOMMAND_ENTRY_AUTO(CFormApp, W_Form, _fdist, fdist, ACRX_CMD_TRANSPARENT, NULL)
